---
- name: install packages
  portage:
    name: "{{ item }}"
    quiet: yes
    getbinpkg: yes
  with_items:
    - dev-db/mariadb
    - dev-python/mysql-python

- name: stat /var/lib/mysql/mysql/user.MYD
  stat:
    path: /var/lib/mysql/mysql/user.MYD
  register: mariadbInitialized

- name: set initial root password
  lineinfile:
    dest: /etc/mysql/my.cnf
    insertafter: '^\[mysql\]$'
    line: "password = {{ mariadbConfig['password'] }}"
    state: present
  when: mariadbInitialized.stat.exists == False

- name: create database
  command: emerge --config dev-db/mariadb
  args:
    creates: /var/lib/mysql/mysql/user.MYD

- name: clear initial root password
  lineinfile:
    dest: /etc/mysql/my.cnf
    insertafter: '^\[mysql\]$'
    line: "password = {{ mariadbConfig['password'] }}"
    state: absent

- name: configure daemon
  lineinfile:
    dest: /etc/mysql/my.cnf
    regexp: '^bind-address.*=.*'
    line: 'bind-address = 0.0.0.0'
    state: present
  notify:
    - restart mariadb

- name: create initscript symlinks
  file:
    src: /etc/init.d/mysql
    dest: /etc/runlevels/default/mysql
    state: link

- name: start initscript
  service:
    name: mysql
    state: started

- name: create user
  mysql_user:
    name: "{{ item['key'] }}"
    host: "{{ item['value']['host'] | default('%')}}"
    password: "{{ item['value']['password'] }}"
    priv: "{{ item['key'] }}.*:ALL"
    state: present
    login_user: root
    login_password: "{{ mariadbConfig['password'] }}"
  with_dict: "{{ (mariadbConfig | default({}))['user'] | default({}) }}"

- name: create database
  mysql_db:
    name: "{{ item['key'] }}"
    state: present
    login_user: root
    login_password: "{{ mariadbConfig['password'] }}"
  with_dict: "{{ (mariadbConfig | default({}))['user'] | default({}) }}"
